
#    Note:  This is loaded into the namespace  Check

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable SYNC_Base_Collected 0
    variable WR_Base_Collected 0
	
	for {set i 0} {$i <= 32} {incr i} {	variable Last_Asic_sync$i 0 }
	
    variable allmodules 0
	variable console { "Nothing Received" } 
	 
    for {set i 0} {$i <= 11} {incr i} {variable Opt$i 0}
	
proc do_clock_source {} {
    set ::AIDA::FEE64 [ lindex $::AIDA::ModuleMenu 1 ]
	set fw_string [ReadAIDARegister [expr 0x000 + 10]]
	if { (( $fw_string >> 24 ) & 0xff  ) == 0x49 } {
		variable TimeSource "White Rabbit"
	} else { 
		variable TimeSource "MACB local"
	}

}

   proc  show_variables {} {
       variable allmodules
	   variable TimeSource 

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
	   InsertLog "Timestamp source is $TimeSource"
	   InsertLog "Version Fred "
	   

   }
  proc do_clock_check {} {
	variable console {}
    set TSMaster $::AIDA::TSMaster
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
	set Mpassed 0
	set Mfailed 0
    foreach fee64 $::AIDA::ModuleMenu {
	    set ::AIDA::FEE64 $fee64
		set Test1 [expr 7 & [ ReadAIDARegister 1] ]
		if { $Test1 == 0x07 } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			lappend console "FEE64 module $fee64 global clocks failed, $Test1\n "
		}
		set fw_string [ReadAIDARegister [expr 0x000 + 10]]
		if { (( $fw_string >> 24 ) & 0xff ) != 0x49 } {
			set d1 [ expr ( ( $fw_string >> 8 ) & 0xf ) ]
			if { $d1 >= 5 && $fee64 == $TSMaster } {
				set Test2 [expr 0x10000 & [ ReadAIDARegister 0x40d] ]
				if { $Test2 == 0x10000 } {
					set Mpassed [ expr $Mpassed + 1 ]
				} else {
					set Mfailed [ expr $Mfailed + 1 ]
					lappend console "FEE64 Master module $fee64 SYNC clock failed, $Test2\n"
					lappend console "Master Clock status test result: Passed $Mpassed, Failed $Mfailed\n"
				}
			}
		}
	}
	lappend console "Clock status test result: Passed $passed, Failed $failed\n"
	lappend console "\nUnderstand status as follows\n"
	lappend console "Status bit 3 : firmware PLL that creates clocks from external clock not locked\n"
	lappend console "Status bit 2 : always logic '1' \n"
	lappend console "Status bit 1 : LMK3200(2) PLL and clock distribution chip not locked to external clock\n"
	lappend console "Status bit 0 : LMK3200(1) PLL and clock distribution chip not locked to external clock\n"
	lappend console "If all these bits are not set then the operation of the firmware is unreliable\n"
	

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

  proc do_cal_check {} {
  	variable console {}

      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 set Test1 [ ReadAIDARegister 0x802 ]
		 set Test2 [ ReadAIDARegister 0x803 ]
		 set Test3 [ ReadAIDARegister 0x804 ]
		if { $Test1 == 0xff && $Test2 == 0xf7 && $Test3 == 0xff } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			lappend console "FEE64 module $fee64 failed\n"
		}
      }
	lappend console "Calibration test result: Passed $passed, Failed $failed\n"
	lappend console "\nIf any modules fail calibration , check the clock status and open the FADC Align and Control browser page to rerun calibration for that module\n"
      set ::AIDA::FEE64 $BAK   ;#   restore
   }
  proc do_stamp_check {} {
  	variable console {}
	
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
      foreach fee64 $::AIDA::ModuleMenu {
		variable Last_Asic_sync$fee64
	    set ::AIDA::FEE64 $fee64
		set Test1 [ ReadAIDARegister 0x309 ]
		lappend console "FEE64 module $fee64 failed => \t$Test1 , \t[expr $Test1 & 7 ]\t Last Time =>\t[set Last_Asic_sync$fee64]\n"
		
      }
	lappend console "\n\nASIC Clock Timestamp check test result: Passed $passed, Failed $failed\n"
	lappend console "\n This test is under developement.\n"
      set ::AIDA::FEE64 $BAK   ;#   restore
   }

 proc do_sync_checkRx {} { ;# cause a resync but don't request slaves load their Timestamps and don't reset the SYNC counters
	variable console {}

	set BAK $::AIDA::FEE64   ;#   save
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		  WriteAIDARegister 0x400 1 ; # Force the Slave to not be in ReSYNC mode!
	}

	set ::AIDA::FEE64 $::AIDA::TSMaster   ;# select Master
            WriteAIDARegister 0x412 0            ;# write to copy timestamp 
            set MTimeH [ReadAIDARegister 0x413]   ;# read timestamp high 32 bits
            set MTimeL [ReadAIDARegister 0x412]   ;# read timestamp low 32 bits

            lappend console "Current master timestamp from $::AIDA::FEE64 is $MTimeH $MTimeL\n"

            if {[expr ($MTimeL >> 28) & 0xf] >= 0xe} {
                set NewTimeL 0x20000000   ; # extended the period between the current time and the resync time by 0x10000000
                set NewTimeH [format 0x%08x [expr $MTimeH + 1]]
            } else {
                set NewTimeL [format 0x%08x [expr ($MTimeL & 0xf0000000) + 0x30000000]]
                set NewTimeH $MTimeH
            }

            WriteAIDARegister 0x417 $NewTimeL    ;#   load timestamp used by master to generate ReSYNC pulse
            WriteAIDARegister 0x418 $NewTimeH    ;# 

            WriteAIDARegister 0x410 0xB        ;#   master generates RESYNC request but doesn't reset the number of SYNCs issued.

            lappend console "ReSync at time $NewTimeH $NewTimeL\n"
#    check status from the master

      for {set i 0} {$i < 10} {incr i} {

         set STATUS [ReadAIDARegister 0x411]    ;#  Master timestamp status
         if {$STATUS == 0x1} {
             lappend console "Master ReSync done\n"
             break
         } else {
             after 2000  ;#  wait a bit longer
         }
      }

      if {$i == 10} {lappend console "Warning: Master ReSync NOT complete"}
      WriteAIDARegister 0x410 1 ;# reset the ReSync request in the Master

 	set Master_issued [ ReadAIDARegister 0x41B ] ;# read the number the Master thinks it sent out
	lappend console "Master issued [format "%d" $Master_issued ] SYNC pulses\n"
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		  WriteAIDARegister 0x40F 1 ; # the slave will show the number of SYNCs received up to the ReSYNC.
		  set val [ ReadAIDARegister 0x407 ]
		  lappend console "Slave $fee64 counted [format "%d" $val ] SYNC pulses\n"
		  WriteAIDARegister 0x40F 0 ; # the slave will show the number of SYNCs being counted.
	}
	set ::AIDA::FEE64 $BAK   ;#   restore
   }

 proc do_sync_check {} {
 	variable console {}

	variable SYNC_Base_Collected
      set BAK $::AIDA::FEE64   ;#   save
	set passed 0
	set failed 0
	if { $SYNC_Base_Collected == 0 } { Collect_SYNC_Base }

      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		 variable Sync_Base_$fee64
		 set Test1 [ ReadAIDARegister [ expr 0x400 + 14] ] 

		if { $Test1 == [ set Sync_Base_$fee64 ] } {
			set passed [ expr $passed + 1 ]
		} else {
			set failed [ expr $failed + 1 ]
			lappend console "FEE64 module $fee64 failed. Base reading : [ set Sync_Base_$fee64 ] , Current reading $Test1 \n"
		}
      }
	lappend console "Sync error counter test result: Passed $passed, Failed $failed\n"
      set ::AIDA::FEE64 $BAK   ;#   restore
}

 

 proc do_sync_asics {} { ;# cause a resync but don't request slaves load their Timestamps and don't reset the SYNC counters
	variable console {}

	set BAK $::AIDA::FEE64   ;#   save
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		  WriteAIDARegister 0x400 1 ; # Force the Slave to not be in ReSYNC mode!
		  set myval [ ReadAIDARegister 0x300 ]
		  WriteAIDARegister 0x300 [ expr $myval | 0x10000 ] ;# enable the resync synchronisation
	}

	set ::AIDA::FEE64 $::AIDA::TSMaster   ;# select Master
            WriteAIDARegister 0x412 0            ;# write to copy timestamp 
            set MTimeH [ReadAIDARegister 0x413]   ;# read timestamp high 32 bits
            set MTimeL [ReadAIDARegister 0x412]   ;# read timestamp low 32 bits

            lappend console "Current master timestamp from $::AIDA::FEE64 is $MTimeH $MTimeL\n"

            if {[expr ($MTimeL >> 28) & 0xf] >= 0xe} {
                set NewTimeL 0x20000000   ; # extended the period between the current time and the resync time by 0x10000000
                set NewTimeH [format 0x%08x [expr $MTimeH + 1]]
            } else {
                set NewTimeL [format 0x%08x [expr ($MTimeL & 0xf0000000) + 0x30000000]]
                set NewTimeH $MTimeH
            }

            WriteAIDARegister 0x417 $NewTimeL    ;#   load timestamp used by master to generate ReSYNC pulse
            WriteAIDARegister 0x418 $NewTimeH    ;# 

            WriteAIDARegister 0x410 0xB        ;#   master generates RESYNC request but doesn't reset the number of SYNCs issued.

            lappend console "ReSync at time $NewTimeH $NewTimeL\n"
#    check status from the master

      for {set i 0} {$i < 10} {incr i} {

         set STATUS [ReadAIDARegister 0x411]    ;#  Master timestamp status
         if {$STATUS == 0x1} {
             lappend console "Master ReSync done\n"
             break
         } else {
             after 2000  ;#  wait a bit longer
         }
      }

      if {$i == 10} {lappend console "Warning: Master ReSync NOT complete\n"}
      WriteAIDARegister 0x410 1 ;# reset the ReSync request in the Master

 	set Master_issued [ ReadAIDARegister 0x41B ] ;# read the number the Master thinks it sent out
	lappend console "Master issued [format "%d" $Master_issued ] SYNC pulses\n"
      foreach fee64 $::AIDA::ModuleMenu {
	          set ::AIDA::FEE64 $fee64
		  set status [ ReadAIDARegister 0x302 ] 
		  lappend console "Slave $fee64 Status register = $status\n"
		  set myval [ ReadAIDARegister 0x300 ]
		  WriteAIDARegister 0x300 [ expr $myval & 1 ] ;# disable the resync synchronisation but leave go as it was

	}
	set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc do_redisplay {} {
}

   proc do_collect_info {} {
	global env
	variable console
	set console {}
    set BAK $::AIDA::FEE64   ;#   save

	set r [namespace eval ::DataAcquisitionControl do_setopt "CollectInfo"]
	after 500 ;# wait for the files to be written
	lappend console "Returned $r \n"
	lappend console "Mem(KB) :\t4\t8\t16\t32\t64\t128\t256\t512\t1k\t2k\t4k\n"
	set f [ file join /Embedded XilinxLinux ppc_4xx rfs ]
      	foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		set mybuddy [ file join $f $fee64 tmp mybuddy.txt ]
		for { set i 0 } { $i < 10 } { incr i } {
			set file_size [ file size $mybuddy ]
			if { $file_size > 0 } break ;
			after 500 
		}
#InsertLog "$fee64 : took $i loops"
		set fp [ open $mybuddy r ]
		set results [ read $fp ]
		set Rlist [split $results ]
		set Dposn [ expr [ lsearch $Rlist "DMA" ] + 1 ]
		set Vlist [ lrange $Rlist $Dposn end ] ;# extracted just the numbers 
#InsertLog "$Vlist, $Dposn"
		set size_value 4
		set mem_total 0
		foreach val $Vlist {
			if { $val != "" } {
				set mem_total [ expr $size_value * $val + $mem_total ]
				set size_value [ expr $size_value * 2 ]
			}
		}
		set Ostring [ join $Vlist ]
		lappend console "$fee64 : $Ostring : $mem_total\n"	
	}
      set ::AIDA::FEE64 $BAK   ;#   restore
}

   proc Show_SYNCRX_Counters {} {
   	variable console {}

    set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		set val$fee64 [ ReadAIDARegister [ expr 0x400 + 7] ]
	}
     foreach fee64 $::AIDA::ModuleMenu {
		lappend console "$fee64 => [format "%d" [ set val$fee64 ] ]\n"
	}
      set ::AIDA::FEE64 $BAK   ;#   restore
}
 
   proc Show_SYNC_Counters {} {
   	variable console {}

    set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		set val [ ReadAIDARegister [ expr 0x400 + 14] ]
		lappend console "$fee64 => [format "%d" $val ]\n"
	}
      set ::AIDA::FEE64 $BAK   ;#   restore
}

   proc Collect_SYNC_Base {} {
   	variable console {}

     variable SYNC_Base_Collected
     set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		variable Sync_Base_$fee64
		set Sync_Base_$fee64 [ ReadAIDARegister [ expr 0x400 + 14] ]
	}
      set SYNC_Base_Collected 1
      set ::AIDA::FEE64 $BAK   ;#   restore
}
   proc do_wrstatus {} {
   	variable console {}

	variable WR_Base_Collected
     set BAK $::AIDA::FEE64   ;#   save
	set passed 0 
	set failed 0
	if { $WR_Base_Collected == 0 } { Collect_WR_Base }
      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		variable WR_Base_$fee64
		set base [ set WR_Base_$fee64 ]
		set wrcount [ ReadAIDARegister [ expr 0x400 + 2] ]
		set wrstatus [ ReadAIDARegister [ expr 0x400 + 1  ] ]
		if { $wrcount != $base || $wrstatus != 0 } {
			if { $failed == 0 } { lappend console  "\t\t Base \t\tCurrent \tDifference\n" }
			set failed [ expr $failed + 1]
			set diff [ expr $wrcount - $base ]
			lappend console "$fee64 fault \t $base : \t $wrcount : \t $diff  \n"
			if { $wrstatus != 0 } { lappend console "$fee64 : WR status $wrstatus\n " }
		} else {
			set passed [ expr $passed +1 ]
		}
		
	}
	lappend console "White Rabbit error counter test result: Passed $passed, Failed $failed\n"
	lappend console "\nUnderstand the status reports as follows:-\n"
	lappend console "Status bit 3 : White Rabbit decoder detected an error in the received data\n"
	lappend console "Status bit 2 : Firmware registered WR error, no reload of Timestamp\n"
	lappend console "Status bit 0 : White Rabbit decoder reports uncertain of Timestamp information from WR\n"
	
      set ::AIDA::FEE64 $BAK   ;#   restore
}
proc TR_collect {} {;# collect and display the timstamp ram contents
		variable console {}
    set BAK $::AIDA::FEE64   ;#   save
	set LSBs 128
	set MSBs 160
		foreach fee64 $::AIDA::ModuleMenu {
			set ::AIDA::FEE64 $fee64
			set status [ ReadAIDARegister [ expr 0x300 + 64 ] ]
			set stop_flag [ expr ($status & 0x100 ) >> 8 ]
			lappend console "\n $fee64 timestamp memory"
			if { $stop_flag == 1 } { 
				lappend console "\tStopped at address [ expr ( $status & 0x1f ) ] : $status "
			} else {
				lappend console "\tNo stop found : $status"
			}
			for { set i 0 } { $i < 32 } {  incr i } {
				if { [ expr $i & 3 ] == 0 } { lappend console "\n$i\t" }
				set lower [ ReadAIDARegister [ expr 0x300 + $LSBs + $i ] ]
				set upper [ ReadAIDARegister [ expr 0x300 + $MSBs + $i ] ]
				set timestamp [ expr ( $upper << 32 ) + $lower ]
				set fmtime [ format "%0llx" $timestamp ]
				lappend console "\t$fmtime"
			}
			lappend console "\n"
		}
    set ::AIDA::FEE64 $BAK   ;#   restore
}
proc TR_start {} {
	variable console {}
    set BAK $::AIDA::FEE64   ;#   save
	foreach fee64 $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $fee64
		WriteAIDARegister [expr 0x300 + 64 ] 0 ;# clear any enables already set and reset any stopped FEEs
		WriteAIDARegister [ expr 0x300 + 64 ]  1 ; # enable the timestamp tracing
	}
	lappend console "all FEEs enabled for Readout Timestamp error tracing\n"
	
    set ::AIDA::FEE64 $BAK   ;#   restore
}	
   proc Collect_WR_Base {} {
   	variable console {}
     variable WR_Base_Collected
     set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		variable WR_Base_$fee64
		set WR_Base_$fee64 [ ReadAIDARegister [ expr 0x400 + 2] ]
	}
      set WR_Base_Collected 1
      set ::AIDA::FEE64 $BAK   ;#   restore
}

 proc do_TS_errors {} {
 	variable console {}

	variable TS_Base_Collected
     set BAK $::AIDA::FEE64   ;#   save
	set passed 0 
	set failed 0
	if { $TS_Base_Collected == 0 } { collect_TS_Base }
      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		variable TS_Base_$fee64
		set base [ set TS_Base_$fee64 ]
		set tscount [ ReadAIDARegister [ expr 0x300 + 3] ]
		if { $tscount != $base  } {
			if { $failed == 0 } { lappend console "\t\t\t Base \t\tCurrent \t\tDifference\n" }
			set failed [ expr $failed + 1]
			set diff [ expr $tscount - $base ]
			lappend console "$fee64 fault \t $base : \t $tscount : \t $diff  \n"
		} else {
			set passed [ expr $passed +1 ]
		}
		
	}
	lappend console "FPGA Timestamp error counter test result: Passed $passed, Failed $failed\n"
	lappend console "If any of these counts are reported as in error\n"
	lappend console "The ASIC readout system has detected a timeslip.\n"
	lappend console "That is the timestamp read from the time FIFO is not younger than the last\n"
	
      set ::AIDA::FEE64 $BAK   ;#   restore
}
   proc collect_TS_Base {} {
   	variable console {}

     variable TS_Base_Collected
     set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
	  	set ::AIDA::FEE64 $fee64
		variable TS_Base_$fee64
		set TS_Base_$fee64 [ ReadAIDARegister [ expr 0x300 + 3] ]
	}
      set TS_Base_Collected 1
      set ::AIDA::FEE64 $BAK   ;#   restore
}

   proc Sync_ASIC_Clock {} {

     set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $fee64
		variable Last_Asic_sync$fee64
		set Last_Asic_sync$fee64 [ expr [ReadAIDARegister 0x309] & 7 ]
		set val [ ReadAIDARegister 0x300 ]
		WriteAIDARegister 0x300 [ expr $val | 0x10000	] ;# enable the ASIC clock synchronisation
     }

      after 500 			;# allow time for one sync pulses when WR set to 0x4000

      foreach fee64 $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $fee64
		set val [ ReadAIDARegister 0x300 ]
		WriteAIDARegister 0x300 [ expr $val & 0xFFFF ]		;# remove the enable the ASIC clock synchronisation
     }
      set ::AIDA::FEE64 $BAK   ;#   restore
	do_stamp_check

}
   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

		STAMP_CHECK {do_stamp_check}
		CAL_CHECK	{do_cal_check}
		CLOCK_CHECK { do_clock_check }
		SYNC_CHECK { do_sync_check }
		SYNC_CHECKRX { do_sync_checkRx }
		COLLECTINFO { do_collect_info }
		WRSTATUS { do_wrstatus }
		TSERRORS { do_TS_errors }

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }
	do_clock_source

}   ;# end of if {$started == 0}




